<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" label-width="68px">
      <el-form-item label="组名称" prop="groupname">
        <el-input
          v-model="queryParams.groupname"
          placeholder="请输入组名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="人员账号" prop="accounts">
        <el-input
          v-model="queryParams.accounts"
          placeholder="请输入人员账号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="人员姓名" prop="accountNames">
        <el-input
          v-model="queryParams.accountNames"
          placeholder="请输入人员姓名"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:contacts:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:contacts:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:contacts:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['system:contacts:export']"
        >导出</el-button>
      </el-col>
    </el-row>

    <el-table :data="contactsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="分组id" align="center" prop="id" />
      <el-table-column label="组名称" align="center" prop="groupname" />
      <el-table-column label="人员账号" align="center" prop="accounts" />
      <el-table-column label="人员姓名" align="center" prop="accountNames" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:contacts:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:contacts:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改常用联系人对话框append-to-body -->
    <el-dialog :title="title" :visible.sync="addOpen" width="500px" :modal-append-to-body='false' append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="组名称" prop="groupname" >
          <el-input v-model="form.groupname" placeholder="请输入组名称" />
        </el-form-item>
        <el-form-item label="人员账号" prop="accounts" v-show="false">
          <el-input v-model="form.accounts" placeholder="请输入人员账号" readonly/>
        </el-form-item>
        <el-form-item label="人员姓名" prop="accountNames">
          <el-input v-model="form.accountNames" placeholder="请选择该分组下的联系人" readonly>
            <template slot="append">
              <el-button
                type="primary"
                icon="el-icon-plus"
                size="mini"
                @click="handleSelect" >
                选择人员</el-button>
            </template>
          </el-input>
        </el-form-item>
      </el-form>
      <!-- 选择人员对话框 -->
      <select-user-by-dept style="z-index: 2093;" ref="selectUserByDept" :title="childTitle" :open="childOpen1" :inputName="childAccountnames" :inputAccount="childAccouts" @ok="selectOK" />

      <div slot="footer" class="dialog-footer">
        <el-button @click="cancelp">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listContacts, getContacts, delContacts, addContacts, updateContacts, exportContacts } from "@/api/system/contacts";
import SelectUserByDept from "@/components/SelectRen/selectUserByDept";

export default {
  name: "Contacts",
  components: {SelectUserByDept},
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 常用联系人表格数据
      contactsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      addOpen: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        groupname: undefined,
        accounts: undefined,
        accountNames: undefined,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      childTitle:'',
      childOpen1:false,
      childAccouts:'',
      childAccountnames:''
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询常用联系人列表 */
    getList() {
      this.loading = true;
      listContacts(this.queryParams).then(response => {
        this.contactsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 添加或编辑 弹窗的取消按钮
    cancelp() {
      this.reset();
      this.childOpen1=false;
      this.addOpen = false;
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        groupname: undefined,
        accounts: undefined,
        accountNames: undefined,
        createBy: undefined,
        createTime: undefined
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!=1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      //选择人员弹框 初始化
      this.childAccouts = '';
      this.childAccountnames = '';
      this.childOpen1=false;
      this.childTitle='';

      this.addOpen = true;
      this.title = "添加常用联系人";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getContacts(id).then(response => {
        this.form = response.data;
        //选择人员弹框 初始化
        this.childAccouts = this.form.accounts;
        this.childAccountnames = this.form.accountNames;
        this.childOpen1=false;
        this.childTitle='';

        this.addOpen = true;
        this.title = "修改常用联系人";
      });
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != undefined) {
            updateContacts(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.addOpen = false;
                this.getList();
              }
            });
          } else {
            addContacts(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.addOpen = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除常用联系人编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delContacts(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有常用联系人数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportContacts(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    },
    /** 新增或修改弹出框中的  选择人员 按钮弹窗操作 */
    handleSelect() {
      this.$refs.selectUserByDept.childOpen=true;
      this.childOpen1 = true;
      this.childTitle = "选择收件人";
    },
    selectOK(zh, xm) {
      this.childAccouts=zh;
      this.childAccountnames=xm;
      this.form.accounts = zh;
      this.form.accountNames=xm;
      this.childOpen1=false;
    }
  }
};
</script>
